import { Converter, Header, Parameter, UNKNOWN, UNKNOWN_OBJ } from '../entities';
export declare const id = "insomnia-1";
export declare const name = "Insomnia v1";
export declare const description = "Legacy Insomnia format";
declare type Format = 'form' | 'json' | 'text' | 'xml';
interface Item {
    requests: UNKNOWN[];
    name?: string;
    environments?: {
        base: UNKNOWN_OBJ;
    };
    __insomnia?: {
        format: Format;
    };
    authentication?: {
        _type?: 'basic';
        username?: string;
        password?: string;
    };
    headers?: Header[];
    body: string | {
        mimeType: string;
        text?: string;
        params?: Parameter[];
    };
    params: Parameter[];
    url?: string;
    method?: string;
}
export interface Insomnia1Data {
    __export_format: 1;
    items: Item[];
}
export declare const convert: Converter;
export {};
//# sourceMappingURL=insomnia-1.d.ts.map